

CREATE OR REPLACE FUNCTION spPay_New(_PayNo VARCHAR) 
RETURNS SETOF SPStatus AS
$BODY$
DECLARE
	_retval			SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;
	spretCashA_New		SPStatus%ROWTYPE;

	_VendorID		VARCHAR(15);
	_PayType		VARCHAR(5);
	_PayDate		DATE;
	_TotPPaid		DECIMAL(19,4);
	_TotPayAmt		DECIMAL(19,4);
	_OverPay		DECIMAL(19,4);
	_IsContra		BOOLEAN;
	_CrtBy			VARCHAR(10);
	_CrtDate		TIMESTAMP;
	_UpdBy			VARCHAR(10);
	_UpdDate		TIMESTAMP;
	_CbgDate		DATE;
	_PurcNo			VARCHAR(15);
	_PPaidAmt		DECIMAL(19,4);
	_PPaidAmtPret		DECIMAL(19,4);
	_PayDMtd		VARCHAR(4);
	_CashID			VARCHAR(15);
	_CashCBG		VARCHAR(15);
	_PayDAmt		DECIMAL(19,4);
	_GDate			DATE;
	_GDueDate		DATE;
	_RefType		VARCHAR(5);
	_RefNo			VARCHAR;
	_PayD_RefNo		VARCHAR(15);
	_PayDNote		TEXT;

	_CashAmt		DECIMAL(19,4);
	_CashANote		VARCHAR;
	_ExtNote		VARCHAR;
	_LastRefType		VARCHAR(5);

	_CrcID			VARCHAR(5);
	_ExcRate		DECIMAL(19,4);
	_BPAAmt			DECIMAL(19,4);
	_BPANote 		TEXT;

	_TempStr		TEXT;
	
	cPPaid			REFCURSOR;
	cPayD			REFCURSOR;

	_AccCash		VARCHAR(10);
	_AccAsset		VARCHAR(10);
	_AccNo			VARCHAR(10);
	_Count			INT;
	_JnlNo			VARCHAR(15);
	_JnlNote		VARCHAR;
	_isAutoGen		BOOLEAN;

	_VendorID_Check		VARCHAR(15);

	_PerID			VARCHAR(5);
	_BranchID		VARCHAR(10);
	_BranchName		VARCHAR;
	_CBGID			VARCHAR;
	_ACTIVE			BOOLEAN;
	_BPID			VARCHAR;
	_DeptID			VARCHAR(5);
	_PrjID			VARCHAR(5);
	_inout			VARCHAR;
	_NomerCbg		VARCHAR;
	_CbgAmt			DECIMAL(19,4);
	_outbal			DECIMAL(19,4);
	_total			DECIMAL(19,4);
	_ToCustID		VARCHAR;
	_CustIDCBG		VARCHAR;
	_totBpAmt		DECIMAL(19,4);
	_isPosted		BOOLEAN;
	_ClrDate		DATE;
	_AccFcn			VARCHAR(10);
	_AccOver 		VARCHAR(10);
	_IsRetur		BOOLEAN;
	__xt			BOOLEAN;
	_ExcRatePurc		DECIMAL(19,4);
	_SelisihRate		DECIMAL(19,4);
	_JnlNo1			VARCHAR;
	_JnlNote1		VARCHAR;
	_PayNote		VARCHAR;
	_TotalPurc		NUMERIC(19,4);
	_LockDate		DATE;
	_Cnt			INT;
	_ReftypeDesc		VARCHAR;
	_PPaidNote		TEXT;
	_PRetAmt		NUMERIC(19,4);
	_AccName		VARCHAR;
	_totPayDisc		NUMERIC(19,4);
	_AccDisc		VARCHAR;
	_SelisihNote		VARCHAR;
	_FcnAmt			NUMERIC(19,4);
	_OverPayBC		NUMERIC(19,4);
	_TotPayDiscBC		NUMERIC(19,4);
	_CrcIDPPaid		VARCHAR;
	_CrcIDPurc		VARCHAR;
	_CrcIDPret		VARCHAR;
	_ExcRatePPaid		NUMERIC(19,4);
	_ExcRatePayD		NUMERIC(19,4);
	_saldoAkhir		NUMERIC(19,4);
	_saldo			NUMERIC(19,4);
	_PaidAmt		NUMERIC(19,4);
	_PaidAmtBC		NUMERIC(19,4);
	_TotalPaid		NUMERIC(19,4);
	_CrcIDDefa		VARCHAR;
	_PayStatus		VARCHAR;
	_CrcIDFcn		VARCHAR;
	_FisRate		NUMERIC(19,4);
	_PPaidAmtAsli		NUMERIC(19,4);
	_PPaidAmtPretAsli	NUMERIC(19,4);
	_VendorIDPo		VARCHAR;
	_FisRatePPaid		NUMERIC(19,4);
	_CrcIDRcvD		VARCHAR;
	_ExcRateRcvD		NUMERIC(19,4);
	_FisRateRcvD		NUMERIC(19,4);
	_countPurc		INT;
	_isAutoReconcileOut	BOOLEAN;
	_isDraft		BOOLEAN;

	_MRefNo			VARCHAR;
	_MRefType		VARCHAR;
	_AccDP			VARCHAR;

	_PPaidAmtFCN		NUMERIC(19,4);
	_PPaidAmtFCNAsli	NUMERIC(19,4);
	_CashInOut		CHAR(1);

	_DocNo			VARCHAR;
	_ModulID		VARCHAR;

	_DPRevaluation		NUMERIC(19,4);
	_RevaluationWithoutDP	NUMERIC(19,4);
	_RevalDNo		jnld.jnldno%TYPE;

	/** Variable untuk jurnal revaluasi **/
	_ExcRatePRet		NUMERIC(19,4);
	_PPaidAmtBCPurc		NUMERIC(19,4);
	_PPaidAmtBCPRet		NUMERIC(19,4);

	_RegPayNoteJnl		INT;
	_RegPPaidNoteJnl	INT;
	_RegPayNoteCashA	INT;
	_RegPayDNoteCashA	INT;
	_RegPPaidNoteCashA	INT;

BEGIN
	_DeptID:=NULL;
	_PrjID:=NULL;
	_CashInOut:='O';

	_RegPayNoteJnl:=COALESCE(fReg('SHOW_PAYNOTE_JNL'), '0');
	_RegPPaidNoteJnl:=COALESCE(fReg('SHOW_PPAIDNOTE_JNL'), '0');
	_RegPayNoteCashA:=COALESCE(fReg('SHOW_PAYNOTE_CASHA'), '0');
	_RegPayDNoteCashA:=COALESCE(fReg('SHOW_PAYDNOTE_CASHA'), '0');
	_RegPPaidNoteCashA:=COALESCE(fReg('SHOW_PPAIDNOTE_CASHA'), '0');



	SELECT INTO 
		_PerID, _BranchID, _DeptID, _PrjID, _VendorID, _PayType, _PayDate, _PayNote, _TotPPaid, _TotPayAmt, _OverPay, _IsContra, _CrtBy, _CrtDate, _UpdBy, _UpdDate, 
		_CrcID, _isAutoGen, __xt, _totPayDisc, _ExcRate, _OverPayBC, _totPayDiscBC, _FisRate, _isDraft, _MRefNo, _MRefType, _DocNo  
		perid, branchid, deptid, prjid, bpid, paytype, paydate, paynote, totppaid, totpayamt, overpay, iscontra, crtby, crtdate, updby, upddate, 
		crcid, isautogen, _xt, totpaydisc, excrate, overpaybc, totpaydiscbc, fisrate, isdraft, refno, reftype, docno 
	FROM pay WHERE payno=_PayNo;

	IF NOT FOUND THEN
		_retval.ErrNo:=50001;
		_retval.ErrMsg:='Pembayaran #% tidak ditemukan (spPay_New)', _PayNo;
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	IF (_isDraft=TRUE) THEN
		_retval:=(0, 'OK');

		RETURN NEXT _retval;
		RETURN;
	END IF;

	SELECT INTO _LockDate lockdate FROM tlock WHERE transtype='PAY';
	IF(_LockDate IS NOT NULL AND _LockDate>_PayDate) THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg='Pembayaran Melebihi Batas Tanggal Kunci Transaksi ! (spPay_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	IF (_OverPay<0) THEN
		_retval.ErrNo:=50003;
		_retval.ErrMsg:='Total Cara-Bayar < (Total hutang yang dibayar-Diskon) (spPay_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	IF(_PayType='PURC' AND _MRefNo IS NULL) THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg='Tipe Pembayaran Cash Harus Lewat Pembelian Tunai!!(spPay_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;
	
	SELECT INTO _countPurc COUNT(*) FROM ppaid WHERE payno=_PayNo and reftype='PURC';
	SELECT INTO _BranchName branchname FROM branch WHERE branchid=_BranchID;


/** UPDATE Status Voucher Payable jika Plugin Terinstal **/
	SELECT INTO _ModulID modulid FROM modul WHERE modulid='VP';
	IF FOUND THEN
		UPDATE voucpay SET active=FALSE WHERE voucpayno=_DocNo;
	END IF;

	_totBpAmt:=0;
	_ExtNote:='';
	_LastRefType:='';
	OPEN cPPaid FOR
		SELECT reftype, refno, ppaidamt, crcid, excrate, ppaidnote FROM ppaid WHERE payno=_PayNo;
	LOOP
		FETCH cPPaid INTO _RefType, _RefNo, _PPaidAmt, _CrcIDPPaid, _ExcRatePPaid, _PPaidNote;
		EXIT WHEN NOT FOUND;

		IF _RefType='PURC' THEN
			IF (_LastRefType<>'PURC') THEN
				_ExtNote:=_ExtNote||'Beli ';
				_LastRefType:='PURC';
			END IF;

			SELECT INTO _VendorID_Check, _CrcIDPurc vendorid, crcid FROM purc WHERE purcno=_RefNo;
			IF _VendorID_Check<>_VendorID THEN
				_retval.ErrNo:=50001;
				_retval.ErrMsg:='Supplier yang akan dipotong tidak sesuai dengan supplier yang bayar (spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;	

			IF _CrcIDPurc<>_CrcIDPPaid THEN
				_retval.ErrNo:=50002;
				_retval.ErrMsg:='Mata uang '||_Refno||' tidak sama dengan aslinya! (spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;	


			IF(_PPaidAmt<0) THEN
				--SELECT INTO _spret * FROM spPurc_Pay(_RefNo, _PPaidAmt*(-1));
				_retval.ErrNo:=50003;
				_retval.ErrMsg:='Jumlah Untuk Bayar tidak boleh minus (spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			SELECT INTO _spret * FROM spPurc_Pay(_RefNo, _PPaidAmt, _PayDate);

			_totBpAmt:=_totBpAmt+_PPaidAmt;
		ELSIF _RefType='PRET' THEN

			IF (_LastRefType<>'PRET') THEN
				_ExtNote:=_ExtNote||'R.Beli ';
				_LastRefType:='PRET';
			END IF;

			SELECT INTO _VendorID_Check, _PRetAmt, _CrcIDPRet vendorid, total, crcid FROM pret WHERE pretno=_RefNo;
			IF _VendorID_Check<>_VendorID THEN
				_retval.ErrNo:=50001;
				_retval.ErrMsg:='Supplier yang akan dipotong tidak sesuai dengan supplier yang bayar(spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF _CrcIDPRet<>_CrcIDPPaid THEN
				_retval.ErrNo:=50002;
				_retval.ErrMsg:='Mata uang '||_Refno||' tidak sama dengan aslinya! (spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF (ABS(_PPaidAmt)<>_PRetAmt) THEN
				_retval.ErrNo:=50003;
				_retval.ErrMsg:='Jumlah Melebihi Retur!! (spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF(_countPurc=0) THEN
				_retval.ErrNo:=50004;
				_retval.ErrMsg:='Belum Ada Hutang yang Dipilih? (spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			_totBpAmt:=_totBpAmt+_PPaidAmt;

			SELECT INTO _spret * FROM spPret_Contra(_RefNo);
			IF (_spret.ErrNo<>0) THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
			_IsRetur:=true;

		ELSIF _RefType='DP' THEN
			_AccDP:=fAccDefault('DEPOVEND');
			IF (_PayType='DP') THEN
				SELECT INTO _spret * FROM spDP_New(_VendorID, _PayDate, _MRefNo, COALESCE(_MRefType, 'PAY'), _CrcID, _ExcRate, _FisRate, _PPaidAmt, _AccDP, _PayNo, 'PAY');
				IF (_spret.ErrNo<>0) THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			ELSE
				IF (_CrcIDPPaid!=_CrcID) THEN
					_retval.ErrNo:=50555;
					_retval.ErrMsg:='Mata Uang D.P. tidak sama dengan mata uang Pembayaran (spPay_New)';
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
				
				SELECT INTO _spret * FROM spDPBal_Update(CAST(_RefNo AS BIGINT), _PPaidAmt, _PPaidAmt*_ExcRatePPaid);
				IF (_spret.ErrNo<>0) THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END IF;

			--_totBpAmt:=_totBpAmt+_PPaidAmt;
		ELSIF _RefType='FCN' THEN
			SELECT INTO _VendorID_Check,_FCNAmt,_CrcIDFcn bpid,fcnamt,crcid FROM FCN WHERE FcnNo=_RefNo;
			IF _VendorID_Check<>_VendorID THEN
				_retval.ErrNo:=55555;
				_retval.ErrMsg:='Supplier FCN tidak sama! (spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
			IF _CrcIDFcn<>_CrcIDPPaid THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Mata uang '||_Refno||' tidak sama! (spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF(abs(_PPaidAmt)<>_FcnAmt) THEN
				_retval.ErrNo:=55555;
				_retval.ErrMsg:='Jumlah Tidak Sama Dengan FCN!(spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF(_countPurc=0) THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Belum Ada Hutang yang Dipilih?(spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			UPDATE FCN SET isContra=true WHERE FcnNo=_RefNo;
			IF NOT FOUND THEN
				_retval.ErrNo:=50555;
				_retval.ErrMsg:='Error Update FCN ! (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			SELECT INTO _AccFcn AccFcn FROM FCN WHERE FcnNo=_RefNo;

			_totBpAmt:=_totBpAmt+_PPaidAmt;
		ELSIF _RefType='ACC' THEN
			IF (_LastRefType<>'ACC') THEN
				_ExtNote:=_ExtNote||'Akun ';
				_LastRefType:='ACC';
			END IF;
			/** Nama Akun dijadikan keterangan saja **/
--			SELECT INTO _AccName accname FROM acc where accno=_RefNo;
--			_RefNo:=_AccName;
			_RefNo:=_PPaidNote;

			--_totBpAmt:=_totBpAmt+_PPaidAmt;
		END IF;
		

		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		IF _CrcID<>_CrcIDPPaid THEN
			_retval.ErrNo:=50011;
			_retval.ErrMsg:='Mata uang '||_Refno||' tidak sama! (spPay_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		IF(_RegPPaidNoteCashA='1') THEN
			_ExtNote:=_ExtNote||_RefNo||' ';
		ELSE 
			_ExtNote:='';
		END IF;

	END LOOP;
	CLOSE cPPaid;
	
	OPEN cPayD FOR
		SELECT paydmtd, cashid, paydamt, refno, paydnote, cbgid, crcid, excrate, fisrate
		FROM payd WHERE payno=_PayNo;
	LOOP
		FETCH cPayD INTO _PayDMtd, _CashID, _PayDAmt, _PayD_RefNo, _PayDNote,_CBGID, _CrcIDRcvD, _ExcRateRcvD, _FisRateRcvD;
		EXIT WHEN NOT FOUND;
	
		IF (_PayDMtd='OVER') THEN
			SELECT INTO _VendorID_Check bpid FROM pay WHERE payno=_PayD_RefNo;
			IF _VendorID_Check<>_VendorID THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Supplier yang akan dipotong tidak sesuai dengan supplier yang bayar';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			--- potong lebih bayar -----
			SELECT INTO _spret * FROM spOverPay_Contra(_PayD_RefNo);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

		ELSEIF ((_PayDMtd='CASH') OR (_PayDMtd='BTRF') OR (_PayDMtd='CRC') OR (_PayDMtd='DBC')) THEN
/***
		ELSIF ((_PayDMtd='CRC') OR (_PayDMtd='DBC')) THEN
			_CashAmt:=_PayDAmt*(-1);

			IF ((_PayDMtd='CRC')) THEN
				_CashANote:='Pembayaran #'||_PayNo||', Credit Card:'||COALESCE(_PayDNote, '');
			ELSE
				_CashANote:='Pembayaran #'||_PayNo||', Debit Card'||COALESCE(_PayDNote, '');
			END IF;
			
			SELECT INTO _spret * FROM spCashA_New(
				_CashID, _VendorID, 'PAY', _PayDate, 'O', 'PAY', _PayNo, _CashAmt,
				_ExtNote, true, _CrtBy, _CrtDate, _UpdBy, _UpdDate,
				_PerID, _BranchID, _DeptID, _PrjID, _CrcIDRcvD, _ExcRateRcvD, _FisRateRcvD
			);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
***/

			_CashAmt:=_PayDAmt*(-1);

			IF(_RegPayDNoteCashA='0') THEN
				_PayDNote:='';
			END IF;

			IF (_PayDMtd='BTRF') THEN
				_CashANote:='B.Tranfer, '||COALESCE(_PayDNote, '')||COALESCE(':'||E'\nUntuk Bayar : '||_ExtNote,'');
			ELSIF (_PayDMtd='CASH') THEN
				_CashANote:='Tunai, '||COALESCE(' '||_PayDNote, '')||COALESCE(':'||E'\nUntuk Bayar : '||_ExtNote,'');
			ELSIF (_PayDMtd='CRC') THEN
				_CashANote:='CCard, '||COALESCE(_PayDNote, '')||COALESCE(':'||E'\nUntuk Bayar : '||_ExtNote,'');
			ELSIF (_PayDMtd='DBC') THEN
				_CashANote:='DCard, '||COALESCE(_PayDNote, '')||COALESCE(':'||E'\nUntuk Bayar : '||_ExtNote,'');
			END IF;

			IF(_RegPayNoteCashA='1') THEN
				_CashANote:='Cara Bayar : '||_CashANote||E'\nKeterangan : '||COALESCE(_PayNote,'');
			ELSE
				_CashANote:='Cara Bayar : '||_CashANote;
			END IF;
			
			IF(_BranchID IS NOT NULL OR _BranchID!='') THEN
				_CashANote:=_CashANote||E' :\nCabang : '||COALESCE(_BranchName,'');
			END IF;

			SELECT INTO _isAutoReconcileOut isAutoReconcileOut FROM Cash WHERE CashID=_CashID;

			IF ((_PayDMtd='CASH' OR _PayDMtd='BTRF') AND (_isAutoReconcileOut=FALSE)) THEN

				SELECT INTO _spret * FROM spCashA_New(
					_CashID, _VendorID, 'PAY', _PayDate, 'O', 'PAY', _PayNo, _CashAmt,
					_CashANote, true, _CrtBy, _CrtDate, _UpdBy, _UpdDate,
					_PerID, _BranchID, _DeptID, _PrjID, _CrcIDRcvD, _ExcRateRcvD, _FisRateRcvD
				);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;

				--- saat ini block diatas sama dengan block dibawah, karena d spCashA_New nanti isReconcile akan dicheck & kas tidak akan bertambah/kurang apabila autoreconcilenya FALSE
			ELSE

				SELECT INTO _spret * FROM spCashA_New(
					_CashID, _VendorID, 'PAY', _PayDate, 'O', 'PAY', _PayNo, _CashAmt,
					_CashANote, true, _CrtBy, _CrtDate, _UpdBy, _UpdDate,
					_PerID, _BranchID, _DeptID, _PrjID, _CrcIDRcvD, _ExcRateRcvD, _FisRateRcvD
				);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;

			END IF;


		ELSIF((_PayDMtd='CHQ') OR (_PayDMtd='GIRO')) THEN
			IF (_CBGID IS NULL) THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Tidak ada Cek/BG (spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			SELECT INTO _ACTIVE, _bpid, _inout, _ClrDate active, tobpid, inout, clrdate FROM cbg WHERE cbgid=_CBGID;
			IF (_ACTIVE=false) THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Cek/BG tidak aktif (spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF(_ClrDate is NOT NULL) THEN
				_retval.ErrNo:=50002;
				_retval.ErrMsg:='CBG #'||_CBGID||' sudah di clear kan (spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF(_bpid<>_VendorID) THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Supplier tidak sama dengan Cek/BG!! (spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF(_bpid IS NULL) THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Cek/BG tidak memiliki customer tujuan!! (spPay_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;


			SELECT INTO _CashCBG, _CustIDCBG, _CbgDate, _CbgAmt, _NomerCbg, _crcid, _ExcRate, _ToCustID 
				srccashid, frombpid, cbgdate, cbgamt, cbgno, crcid, excrate, tobpid 
			FROM cbg WHERE cbgid=_CBGID;

			IF(_CbgAmt<>_PayDAmt) THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Pembayaran dengan Giro Harus memiliki jumlah yang sama dengan giro asli nya!';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF(_inout='I') THEN
			
				_ExtNote:='CBG '||_NomerCbg||' dari '||_CustIDCBG;

				SELECT INTO spretCashA_New * FROM spCashA_New(
					_CashCBG, _CustIDCBG, 'CBG', _PayDate, 'I', 'CBG', _CBGID, _CbgAmt,
					_ExtNote , TRUE, NULL, NULL, NULL, NULL,NULL, NULL, NULL, NULl, _CrcIDRcvD, _ExcRateRcvD, _FisRateRcvD);

				IF spretCashA_New.ErrNo<>0 THEN
					_retval.ErrNo:=spretCashA_New.ErrNo;
					_retval.ErrMsg:=spretCashA_New.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
				UPDATE cbg SET active=false, useddate=_PayDate WHERE cbgid=_CBGID;
			ELSIF(_inout='O') THEN
				/*SELECT INTO _outbal outbal FROM cash WHERE cashid=_CashCBG;
				_total:=_outbal+_CbgAmt;

				UPDATE cash set outbal=total where cashid=_CashCBG;*/
				UPDATE cbg SET active=false, useddate=_PayDate WHERE cbgid=_CBGID;
			END IF;

		END IF;

	END LOOP;
	CLOSE cPayD;

	--_BPAAmt=_TotPPaid;	-- pembayaran : potong hutang (+) 
	SELECT INTO _ExcRatePPaid, _FisRatePPaid excrate, fisrate FROM ppaid WHERE payno=_PayNo;
	_BPAAMT:=_totBpAmt;
	_BPANote='Pembayaran #'||_PayNo;
	IF _PayType='PAY' THEN
		SELECT INTO _spret * FROM spBPA_New(
			_VendorID, 'P',_CrcID, _PayDate, 'PAY', _PayNo, _BPAAmt, 
			_BPANote, true, _CrtBy, _CrtDate, _UpdBy, _UpdDate,
			_PerID, _BranchID, _DeptID, _PrjID, _ExcRatePPaid, _FisRatePPaid
		);
		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	END IF;

	SELECT INTO _CrcIDDefa crcid FROM crc where isdefault=true;


/* /////////////// AKUNTANSI ////////////////////// */

	IF isAccInstalled() AND _isAutoGen=false THEN

		IF(_IsRetur=TRUE AND _TotPPAID=0) THEN
			_retval:=(0, 'OK');
		ELSE
			_JnlNo:=fTransNoGet('JURNAL');
			IF (_PayType='DP') THEN
				_JnlNote:='Pembayaran Uang Muka ';
			ELSE
				_JnlNote:='Pembayaran ';				
			END IF;

			IF (_RegPayNoteJnl='0') THEN
				_PayNote:='';
			END IF;

			IF ((_PayNote IS NULL OR _PayNote='')) THEN
				_JnlNote:= ''||_JnlNote||''||fBPName(_VendorID)||':'||_PayNo;
			ELSE
				_JnlNote:= ''||_JnlNote||''||fBPName(_VendorID)||':'||_PayNo||E' \nKeterangan : '|| _PayNote;
			END IF;
			SELECT INTO _spret * FROM spJnl_Insert(_JnlNo,'PAY',_PayDate,'PAY',_PayNo,
				_JnlNote,true,true,cast(0 as NUMERIC(19,4)),_CrtBy,_CrtDate,_UpdBy,_UpdDate,
				_PerID, _BranchID, _DeptID, _PrjID,__xt, _CrcID, _ExcRate, _FisRate
			);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			_Count:=0;

			/** cek akun dp */
			IF (_PayType='DP') THEN
				_AccDP:=fAccDefault('DEPOVEND');
				IF (_AccDP IS NULL OR _AccDP='') THEN
					_retval.ErrNo:=50555;
					_retval.ErrMsg:=E'Default akun deposit Supplier belum disetting\nSilahkan disetting melalui form default akun (spPay_New)';
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END IF;

			SELECT INTO 
				_PPaidAmtPret, _PPaidAmtPretAsli 
				SUM(ppaidamt*excrate), SUM(ppaidamt) 
			FROM ppaid WHERE payno=_PayNo and reftype='PRET';

			_PPaidAmtPret:=COALESCE(_PPaidAmtPret, 0);
			_PPaidAmtPretAsli:=COALESCE(_PPaidAmtPretAsli, 0);

			SELECT INTO 
				_PPaidAmtFCN, _PPaidAmtFCNAsli 
				SUM(ppaidamt*excrate), SUM(ppaidamt) 
			FROM ppaid WHERE payno=_PayNo and reftype='FCN';

			_PPaidAmtFCN:=COALESCE(_PPaidAmtFCN, 0);
			_PPaidAmtFCNAsli:=COALESCE(_PPaidAmtFCNAsli, 0);

			_IsPosted:=false;

			OPEN cPPaid FOR
				SELECT reftype, (CASE WHEN reftype='PURC' THEN fAccTrans('PURC', refno, 'AP') WHEN reftype='DP' THEN _AccDP ELSE refno END), 
				SUM(ppaidamt*excrate), SUM(ppaidamt), deptid, prjid, SUM(ppaidnote), crcid 
				FROM ppaid 
				WHERE payno=_PayNo AND reftype NOT IN ('PRET', 'FCN')
				GROUP BY reftype, (CASE WHEN reftype='PURC' THEN fAccTrans('PURC', refno, 'AP') WHEN reftype='DP' THEN _AccDP ELSE refno END), deptid, prjid, crcid;
			LOOP
				FETCH cPPaid INTO _RefType, _RefNo, _PPaidAmt, _PPaidAmtAsli, _DeptID, _PrjID, _PPaidNote, _crcIDPPaid;
				EXIT WHEN NOT FOUND;

				_Count:=_Count+1;

				IF(_RegPPaidNoteJnl='0') THEN
					_PPaidNote:='';
				ELSE
					_PPaidNote:=E'\nUntuk Bayar : '||_PPaidNote||'';
				END IF;

				IF _RefType='PURC' THEN
					IF((_PPaidAmtPret!=0 OR _PPaidAmtFCN!=0) AND (_IsPosted=false)) THEN
					--SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo,_Count,fBpAcc(_VendorID,_crcIDPPaid,'AP'),'D',(_PPaidAmt*_ExcRatePPaid)+_PPaidAmtPret,_DeptID,_PrjID, _PPaidNote,_PPaidAmt+_PPaidAmtPretAsli);
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _RefNo, 'D', _PPaidAmt+_PPaidAmtPret+_PPaidAmtFCN, _DeptID, _PrjID, _PPaidNote, _PPaidAmtAsli+_PPaidAmtPretAsli+_PPaidAmtFCNAsli);
						_IsPosted:=true;
					ELSE
					--SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo,_Count,fBpAcc(_VendorID,_crcIDPPaid,'AP'),'D',_PPaidAmt*_ExcRatePPaid,_DeptID,_PrjID, _PPaidNote,_PPaidAmt);
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _RefNo, 'D', _PPaidAmt, _DeptID, _PrjID, _PPaidNote, _PPaidAmtAsli);
					END IF;
				ELSIF _RefType='ACC' THEN
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _RefNo, 'D', _PPaidAmt, _DeptID, _PrjID, _PPaidNote, _PPaidAmtAsli);
				ELSIF _RefType='DP' THEN
					IF (_PayType='DP') THEN
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _AccDP, 'D', _PPaidAmt, _DeptID, _PrjID, _PPaidNote, _PPaidAmtAsli);
					ELSE
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _AccDP, 'D', _PPaidAmt, _DeptID, _PrjID, _PPaidNote, _PPaidAmtAsli);
					END IF;
				END IF;

				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END LOOP;
			CLOSE cPPaid;

			OPEN cPayD FOR
				SELECT paydmtd, cashid, paydamt, refno, paydnote, excrate, cbgid
				FROM payd WHERE payno=_PayNo;
			LOOP
				FETCH cPayD INTO _PayDMtd, _CashID, _PayDAmt, _PayD_RefNo, _PayDNote, _ExcRatePayD, _CBGID;
				EXIT WHEN NOT FOUND;
				_Count:=_Count+1;

				IF (_PayDMtd='OVER') THEN
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, fAccDefault('DEPOVEND'), 'K', _PayDAmt*_ExcRatePayD, NULL, NULL, _PayDAmt);
				ELSEIF ((_PayDMtd='CASH') OR (_PayDMtd='BTRF') OR (_PayDMtd='DBC') OR (_PayDMtd='CRC')) THEN
					_AccCash:=fAccCash(_CashID, _CashInOut);

					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _AccCash, 'K', _PayDAmt*_ExcRatePayD, NULL, NULL, _PayDAmt);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				ELSIF((_PayDMtd='CHQ') OR (_PayDMtd='GIRO')) THEN
					SELECT INTO _CashCBG srccashid FROM cbg WHERE cbgid=_CBGID;

					IF(_inout='I') THEN
						_AccAsset:=fAccCash(_CashCBG, _CashInOut);
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _AccAsset, 'K', _PayDAmt*_ExcRatePayD, NULL, NULL, _PayDAmt);
						IF _spret.ErrNo<>0 THEN
							_retval.ErrNo:=_spret.ErrNo;
							_retval.ErrMsg:=_spret.ErrMsg;
							RAISE EXCEPTION '%', _retval.ErrMsg;
						END IF;
					ELSIF(_inout='O') THEN
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, fAccDefault('OPENCBG'), 'K', _PayDAmt*_ExcRatePayD, NULL, NULL, _PayDAmt);
						IF _spret.ErrNo<>0 THEN
							_retval.ErrNo:=_spret.ErrNo;
							_retval.ErrMsg:=_spret.ErrMsg;
							RAISE EXCEPTION '%', _retval.ErrMsg;
						END IF;
					END IF;
				END IF;

				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END LOOP;
			CLOSE cPayD;

			_OverPayBC:=COALESCE(_OverPayBC, 0);
			IF (_OverPayBC<>0) THEN
				_AccOver:=fAccDefault('DEPOVEND');

				_Count:=_Count+1;
				SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _AccOver, 'D', _OverPayBC, NULL, NULL,_OverPay);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END IF;

			_totPayDiscBC:=COALESCE(_totPayDiscBC,0);
			IF (_totPayDiscBC<>0) THEN
				_AccDisc:=fAccDefault('PURCDISC');

				_Count:=_Count+1;
				SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _AccDisc, 'K', _totPayDiscBC, NULL, NULL, _totPayDisc);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END IF;

			SELECT INTO _spret * FROM spJnl_New(_JnlNo);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

		--- Jurnal klo buat ada selisih kurs saat ini ama pembelian waktu itu
			_Cnt:=0;

		--- cek saldo, buat klo ada selisih kurs.. ------
			_saldoAkhir:=0;
			OPEN cPPaid FOR
				SELECT reftype, refno, ppaidamt 
				FROM ppaid 
				WHERE payno=_PayNo AND crcid<>_CrcIDDefa AND reftype IN ('PURC', 'PRET');
			LOOP
				FETCH cPPaid INTO _RefType, _RefNo, _PaidAmt;
				EXIT WHEN NOT FOUND;

				_PaidAmtBC:=_PaidAmt*_Excrate;

				IF(_RefType='PURC') THEN

					SELECT INTO _ExcRatePurc excrate FROM purc WHERE purcno=_RefNo;
				
					_PPaidAmtBCPurc:=_PaidAmt*_ExcRatePurc;
					_saldo:=_PPaidAmtBCPurc-_PaidAmtBC;
				ELSIF(_RefType='PRET') THEN
					SELECT INTO _ExcRatePRet excrate FROM pret WHERE pretno=_RefNo;
				
					_PPaidAmtBCPRet:=_PaidAmt*_ExcRatePRet;
				
					_saldo:=_PPaidAmtBCPRet-_PaidAmtBC;
				END IF;

				_saldoAkhir:=_saldoAkhir+COALESCE(_saldo, 0);
			END LOOP;
			CLOSE cPPaid;

			IF (_PayType!='DP') THEN
				SELECT INTO _DPRevaluation SUM((a.ppaidamt*dp.excrate) - (a.ppaidamt*a.excrate)) 
				FROM dp JOIN (
					SELECT CAST(refno AS BIGINT) AS dpid, ppaidamt, excrate 
					FROM ppaid 
					WHERE reftype='DP' AND payno=_PayNo
				) a ON dp.dpid=a.dpid;

				_DPRevaluation:=COALESCE(_DPRevaluation, 0)*-1;
				_RevaluationWithoutDP:=_saldoAkhir;
				_saldoAkhir:=_saldoAkhir+_DPRevaluation;
			END IF;

			IF(_saldoAkhir<>0 OR _DPRevaluation<>0 OR _RevaluationWithoutDP<>0) THEN
				_RevalDNo:=0;
				_JnlNo1:=fTransNoGet('JURNAL');
				_JnlNote1:= 'Revaluasi Kurs Pembayaran'||':'||_PayNo;

				SELECT INTO _spret * FROM spJnl_Insert(_JnlNo1, 'PAY', _PayDate, 'PAY', _PayNo, 
					_JnlNote1, true, true, CAST(0 AS NUMERIC(19,4)), _CrtBy, _CrtDate, _UpdBy, _UpdDate,
					_PerID, _BranchID, _DeptID, _PrjID, __xt, _CrcID, _ExcRate, _FisRate
				);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;

				IF (_saldoAkhir<0) THEN
					_RevalDNo:=_RevalDNo+1;
					_saldoAkhir:=ABS(_saldoAkhir);
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _RevalDNo, fAccDefault('ACCPROFIT'), 'D', _saldoAkhir, NULL, NULL, _saldoAkhir);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				ELSIF (_saldoAkhir>0) THEN
					_RevalDNo:=_RevalDNo+1;
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _RevalDNo, fAccDefault('ACCPROFIT'), 'K', _saldoAkhir, NULL, NULL, _saldoAkhir);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				END IF;

				IF (_RevaluationWithoutDP<0) THEN
					_RevalDNo:=_RevalDNo+1;
					_RevaluationWithoutDP:=ABS(_RevaluationWithoutDP);
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _RevalDNo, fBpAcc(_VendorID, _CrcID, 'AP'), 'K', _RevaluationWithoutDP, NULL, NULL, _RevaluationWithoutDP);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF; 
				ELSIF (_RevaluationWithoutDP>0) THEN
					_RevalDNo:=_RevalDNo+1;
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _RevalDNo, fBpAcc(_VendorID, _CrcID, 'AP'), 'D', _RevaluationWithoutDP, NULL, NULL, _RevaluationWithoutDP);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				END IF;

				IF (_DPRevaluation<0) THEN
					_RevalDNo:=_RevalDNo+1;
					_DPRevaluation:=ABS(_DPRevaluation);
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _RevalDNo, _AccDP, 'K', _DPRevaluation, NULL, NULL, _DPRevaluation);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				ELSIF (_DPRevaluation>0) THEN
					_RevalDNo:=_RevalDNo+1;
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _RevalDNo, _AccDP, 'D', _DPRevaluation, NULL, NULL, _DPRevaluation);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				END IF;

				SELECT INTO _spret * FROM spJnl_New(_JnlNo1);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END IF;	-- if (saldoAkhir<0)
		END IF; -- _IF (saldoAkhir<>0)
	END IF; -- if (isAcc)


	_retval:=(0, 'OK');
	RETURN NEXT _retval;
END;
$BODY$ 
LANGUAGE 'plpgsql' VOLATILE;




CREATE OR REPLACE FUNCTION spRcv_New(_RcvNo VARCHAR) 
RETURNS SETOF SPStatus AS 
$BODY$
DECLARE
	_retval			SPStatus%ROWTYPE;
	spretSale_Rcv		SPStatus%ROWTYPE;
	spretOverRcv_Contra	SPStatus%ROWTYPE;
	spretDN_Contra		SPStatus%ROWTYPE;
	spretCashA_New		SPStatus%ROWTYPE;
	spretDebt_New		SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;

	_CustID			VARCHAR(15);
	_RcvType		VARCHAR(5);
	_RcvDate		DATE;
	_TotSPaid		DECIMAL(19,4);
	_TotRcvAmt		DECIMAL(19,4);
	_OverRcv		DECIMAL(19,4);
	_IsContra		BOOL;
	_CrtBy			VARCHAR(10);
	_CrtDate		DATE;
	_UpdBy			VARCHAR(10);
	_UpdDate		DATE;
	_RefType		VARCHAR;
	_SaleNo			VARCHAR(15);
	_SPaidAmt		DECIMAL(19,4);
	_SPaidAmtSRet		DECIMAL(19,4);
	_IsPosted		BOOLEAN;

	_RcvDMtd		VARCHAR(4);
	_CashID			VARCHAR(15);
	_RcvDAmt		DECIMAL(19,4);
	_GDate			DATE;
	_GDueDate		DATE;

	_RcvNote		TEXT;
	_RcvDNote		TEXT;

	_CashAmt		DECIMAL(19,4);
	_CashANote		VARCHAR;
	_ExtNote		VARCHAR;
	_LastRefType		VARCHAR(5);


	_DebtAmt		DECIMAL(19,4);
	_totBpAmt		DECIMAL(19,4);
	_DebtNote		VARCHAR(50);
	_TempStr		TEXT;

	_RefNo			VARCHAR;
	_RcvD_RefNo		VARCHAR;
	_CrcID			VARCHAR(5);
	_Inout			VARCHAR(3);
	_CbgID			VARCHAR;
	_SrcCash		VARCHAR;
	_CbgAmt			NUMERIC;
	_CbgDate		DATE;
	cSPaid			REFCURSOR;
	cRcvD			REFCURSOR;


	_AccCash		VARCHAR(10);
	_AccNo			VARCHAR(10);
	_Count			INT;
	_JnlNo			VARCHAR(15);
	_JnlNote		VARCHAR;
	_isAutoGen		BOOLEAN;

	_CustID_Check		VARCHAR(15);

	_PerID			VARCHAR(5);
	_BranchID		VARCHAR(10);
	_BranchName		VARCHAR;
	_ACTIVE			BOOLEAN;
	_BPID			VARCHAR;
	_DeptID			VARCHAR(5);
	_PrjID			VARCHAR(5);

	_AccFcn			VARCHAR(10);
	_AccOver		VARCHAR(10);
	_NomerCbg		VARCHAR;
	_IsRetur		BOOLEAN;
	_ClrDate		DATE;
	_LockDate		DATE;
	_SRetAmt		NUMERIC(19,4);
	_AccName		VARCHAR;
	_TotRcvDisc		NUMERIC(19,4);
	_AccDisc		VARCHAR;
	_ExcRateSale		NUMERIC(19,4);
	_ExcRate		NUMERIC(19,4);
	_SelisihRate		NUMERIC(19,4);
	_SelisihNote		VARCHAR;
	_JnlNo1			VARCHAR;
	_JnlNote1		VARCHAR;
	_FCNAmt			NUMERIC(19,4);
	_OverRcvBC		NUMERIC(19,4);
	_TotRcvDiscBC		NUMERIC(19,4);
	_ExcRateRcvD		NUMERIC(19,4);
	_ExcRateSPaid		NUMERIC(19,4);
	_SPaidAmtSO		NUMERIC(19,4);
	_CrcIDSPaid		VARCHAR;
	_CrcIDSale		VARCHAR;
	_CrcIDSret		VARCHAR;
	_saldoAkhir		NUMERIC(19,4);
	_saldo			NUMERIC(19,4);
	_paidAmt		NUMERIC(19,4);
	_CrcIDDefa		VARCHAR;
	__xt			BOOLEAN;
	_CrcIDFcn		VARCHAR;
	_FisRate		NUMERIC(19,4);
	_SPaidAmtAsli		NUMERIC(19,4);
	_SPaidAmtSretAsli	NUMERIC(19,4);
	_SPaidAmtSOAsli		NUMERIC(19,4);
	_CustIDSO		VARCHAR;
	_FisRateSPaid		NUMERIC(19,4);
	_CrcIDRcvD		VARCHAR;
	_FisRateRcvD		NUMERIC(19,4);
	_countSale		INT;

	_isAutoReconcileIn	BOOLEAN;
	_isDraft		BOOLEAN;

	_MRefNo			VARCHAR;
	_MRefType		VARCHAR;
	_AccDP			VARCHAR;

	_SPaidAmtFCN		NUMERIC(19,4);
	_SPaidAmtFCNAsli	NUMERIC(19,4);
	_CashInOut		CHAR(1);
	_CashCBG		VARCHAR;

	_DPRevaluation		NUMERIC(19,4);
	_RevaluationWithoutDP	NUMERIC(19,4);
	_RevalDNo		jnld.jnldno%TYPE;

	/** Variable untuk jurnal revaluasi **/
	_ExcRateSRet		NUMERIC(19,4);
	_PaidAmtBC		NUMERIC(19,4);
	_SPaidAmtBCSale		NUMERIC(19,4);
	_SPaidAmtBCSRet		NUMERIC(19,4);

	_RegRcvNoteJnl		INT;
	_RegSPaidNoteJnl	INT;
	_RegRcvNoteCashA	INT;
	_RegRcvDNoteCashA	INT;
	_RegSPaidNoteCashA	INT;

	_SPaidNote		TEXT;

BEGIN
	_DeptID:=NULL;
	_PrjID:=NULL;
	_IsRetur:=false;
	_CashInOut:='I';
	_DebtAmt:=0;

	_RegRcvNoteJnl:=COALESCE(fReg('SHOW_RCVNOTE_JNL'), '0');
	_RegSPaidNoteJnl:=COALESCE(fReg('SHOW_SPAIDNOTE_JNL'), '0');
	_RegRcvNoteCashA:=COALESCE(fReg('SHOW_RCVNOTE_CASHA'), '0');
	_RegRcvDNoteCashA:=COALESCE(fReg('SHOW_RCVDNOTE_CASHA'), '0');
	_RegSPaidNoteCashA:=COALESCE(fReg('SHOW_SPAIDNOTE_CASHA'), '0');

	SELECT INTO 
		_PerID, _BranchID, _DeptID, _PrjID, _CustID, _RcvType, _RcvDate, _RcvNote, _TotSPaid, _TotRcvAmt, _OverRcv, _IsContra, _CrtBy, _CrtDate, _UpdBy, _UpdDate, _MRefType, _MRefNo, _CrcID, _perid, _isAutoGen, _TotRcvDisc, _OverRcvBC, _TotRcvDiscBC, __xt, _ExcRate, _FisRate, _isDraft 
		PerID, BranchID, DeptID, PrjID, BPID, RcvType, RcvDate, RcvNote, TotSPaid, TotRcvAmt, OverRcv, IsContra, CrtBy, CrtDate, UpdBy, UpdDate, RefType, RefNo, CrcID, perid, isautogen, TotRcvDisc, OverRcvBC, TotRcvDiscBC, _xt, ExcRate, FisRate, isDraft
	FROM Rcv WHERE RcvNo=_RcvNo;

	IF NOT FOUND THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg:='Penerimaan-pembayaran #'||_RcvNo||' tidak ditemukan (spRcv_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	IF (_isDraft=TRUE) THEN
		_retval:=(0, 'OK');
		RETURN NEXT _retval;
		RETURN;
	END IF;

	SELECT INTO _LockDate lockdate FROM TLock WHERE TransType='RCV';
	IF(_LockDate is not NULL AND _LockDate>_RcvDate) THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg='Penerimaan Pembayaran Melebihi Tanggal Batas Kunci Transaksi ! (spRcv_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	IF (_OverRcv<CAST(0 AS Decimal(19,4))) THEN
		_retval.ErrNo:=50003;
		_retval.ErrMsg:='Total cara bayar < (Total piutang yang dibayar-Diskon) (spRcv_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

/*klo pembayaran penjualan tunai harus autogen nya true!*/
	IF(_RcvType='SALE' AND _MRefNo IS NULL) THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg='Tipe Penerimaan Cash Harus Lewat Penjualan Tunai!! (spRcv_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	SELECT INTO _countSale COUNT(*) FROM spaid WHERE rcvno=_RcvNo and reftype='SALE';
	SELECT INTO _BranchName branchname FROM branch WHERE branchid=_BranchID;

	_ExtNote:='';
	_LastRefType:='';
	_totBpAmt:=0;
	/*** Update Sales Paid (SPaid) ***/
	OPEN cSPaid FOR
		SELECT RefType,Refno, SPaidAmt, CrcID, excrate, spaidnote 
		FROM SPaid 
		WHERE RcvNo=_RcvNo
		ORDER BY RefType, SPaidNo;
	LOOP
		FETCH cSPaid INTO _RefType, _RefNo, _SPaidAmt, _CrcIDSPaid, _ExcRateSPaid, _SPaidNote;
		EXIT WHEN NOT FOUND;

		IF _RefType='SALE' THEN
			IF (_LastRefType<>'SALE') THEN
				_ExtNote:=_ExtNote||'Jual ';
				_LastRefType:='SALE';
			END IF;

			SELECT INTO _CustID_Check, _CrcIDSale custid,crcid FROM sale WHERE saleno=_RefNo;
--RAISE EXCEPTION 'RcvNo : % ; Saleno : % ; Check : % ; Cust : % ; ',_RcvNo,_RefNo,_CustID_Check,_CustID;
			IF _CustID_Check<>_CustID THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Customer yang akan dipotong tidak sesuai dengan customer yang bayar (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF _CrcIDSPaid<>_CrcIDSale THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Mata Uang '||_RefNo||' harus sama dengan mata uang asli nya!! (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF(_SPaidAmt<0) THEN
				SELECT INTO  spretSale_Rcv * FROM spSale_Rcv(_RefNo, _SPaidAmt*(-1), _RcvDate);
			ELSE
				SELECT INTO  spretSale_Rcv * FROM spSale_Rcv(_RefNo, _SPaidAmt, _RcvDate);
			END IF;

			_totBpAmt:=_totBpAmt+_SPaidAmt;
		ELSIF _RefType='SRET' THEN
			IF (_LastRefType<>'SRET') THEN
				_ExtNote:=_ExtNote||'R.Jual ';
				_LastRefType:='SRET';
			END IF;

			SELECT INTO _CustID_Check,_SRetAmt,_CrcIDSret custid,total,crcid FROM sret WHERE sretno=_RefNo;
			IF _CustID_Check<>_CustID THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Customer yang akan dipotong tidak sesuai dengan customer yang bayar (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF _CrcIDSPaid<>_CrcIDSret THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Mata Uang '||_RefNo||' harus sama dengan mata uang asli nya!! (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF (ABS(_SPaidAmt)<>_SRetAmt) THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Jumlah Penerimaan Retur Harus Sama Retur!! (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF(_countSale=0) THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Belum Ada Piutang yang Dipilih? (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			_totBpAmt:=_totBpAmt+_SPaidAmt;
			SELECT INTO spretSale_Rcv * FROM spSret_Contra(_RefNo);
			IF (spretSale_Rcv.ErrNo<>0) THEN
				_retval.ErrNo:=spretSale_Rcv.ErrNo;
				_retval.ErrMsg:=spretSale_Rcv.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
			_IsRetur:=true;
		ELSIF _RefType='DP' THEN
			_AccDP:=fAccDefault('DEPOCUST');
			IF (_RcvType='DP') THEN
				SELECT INTO _spret * FROM spDP_New(_CustID, _RcvDate, _MRefNo, COALESCE(_MRefType, 'RCV'), _CrcID, _ExcRate, _FisRate, _SPaidAmt, _AccDP, _RcvNo, 'RCV');
				IF (_spret.ErrNo<>0) THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			ELSE
				IF (_CrcIDSPaid!=_CrcID) THEN
					_retval.ErrNo:=50555;
					_retval.ErrMsg:='Mata Uang D.P. tidak sama dengan mata uang Pembayaran (spRcv_New)';
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;

				SELECT INTO _spret * FROM spDPBal_Update(CAST(_RefNo AS BIGINT), _SPaidAmt, _SPaidAmt*_ExcRateSPaid);
				IF (_spret.ErrNo<>0) THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END IF;

			--_totBpAmt:=_totBpAmt+_SPaidAmt;
		ELSIF _RefType='FCN' THEN
			SELECT INTO _CustID_Check,_FCNAmt,_CrcIDFcn bpid,fcnamt,CrcID FROM FCN WHERE FcnNo=_RefNo;
			IF _CustID_Check<>_CustID THEN
				_retval.ErrNo:=55555;
				_retval.ErrMsg:='Mitra Bisnis FCN tidak sama dengan Customer yang akan diterima';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF _CrcIDSPaid<>_CrcIDFcn THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Mata Uang '||_RefNo||' harus sama dengan mata uang asli nya!!';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;


			IF(ABS(_SPaidAmt)<>_FcnAmt) THEN
				_retval.ErrNo:=55555;
				_retval.ErrMsg:='Jumlah Tidak Sama Dengan FCN !!';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF(_countSale=0) THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Belum Ada Piutang yang Dipilih?';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		
			UPDATE FCN SET isContra=true WHERE FcnNo=_RefNo;
			IF NOT FOUND THEN
				_retval.ErrNo:=50555;
				_retval.ErrMsg:='FCN tidak ditemukan ! (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
			SELECT INTO _AccFcn AccFcn FROM FCN WHERE FcnNo=_RefNo;
			
			_totBpAmt:=_totBpAmt+_SPaidAmt;
		ELSIF _RefType='ACC' THEN
			IF (_LastRefType<>'ACC') THEN
				_ExtNote:=_ExtNote||'Akun ';
				_LastRefType:='ACC';
			END IF;
--			SELECT INTO _AccName accname FROM acc where accno=_RefNo;
--			_RefNo:=_AccName;
			_RefNo:=_SPaidNote;
		
			--_totBpAmt:=_totBpAmt+_SPaidAmt;
		END IF;

		IF _CrcIDSPaid<>_CrcID THEN
			_retval.ErrNo:=101;
			_retval.ErrMsg:='Mata Uang '||_RefNo||' harus sama dengan mata uang Master Transaksi!!';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		IF spretSale_Rcv.ErrNo<>0 THEN
				_retval.ErrNo:=spretSale_Rcv.ErrNo;
				_retval.ErrMsg:=spretSale_Rcv.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		IF(_RegSPaidNoteCashA='1') THEN
			_ExtNote:=_ExtNote||_RefNo||' ';
		ELSE 
			_ExtNote:='';
		END IF;

	END LOOP;
	CLOSE cSPaid;

/****************************** Generate CashA from RcvD ************************************/

	OPEN cRcvD FOR
		SELECT RcvDMtd, CashID, RcvDAmt, RefNo, 
			RcvDNote,CbgID,CrcID, ExcRate, FisRate  FROM RcvD WHERE RcvNo=_RcvNo;

	LOOP
		FETCH cRcvD INTO _RcvDMtd, _CashID, _RcvDAmt, _RcvD_RefNo, _RcvDNote,_CbgID, _CrcIDRcvD, _ExcRateRcvD, _FisRateRcvD;
		EXIT WHEN NOT FOUND;

		IF (_RcvDMtd='OVER') THEN
			SELECT INTO _CustID_Check bpid FROM rcv WHERE rcvno=_RcvD_RefNo;
			IF _CustID_Check<>_CustID THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Customer yang akan dipotong tidak sesuai dengan customer yang bayar';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;												/** potong lebih bayar */
			SELECT INTO spretOverRcv_Contra * from spOverRcv_Contra(_RcvD_RefNo);
			IF spretOverRcv_Contra.ErrNo<>0 THEN
				_retval.ErrNo:=spretOverRcv_Contra.ErrNo;
				_retval.ErrMsg:=spretOverRcv_Contra .ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

		ELSIF ((_RcvDMtd='CASH') OR (_RcvDMtd='BTRF') OR (_RcvDMtd='CRC') OR (_RcvDMtd='DBC')) THEN

/**
		ELSIF ((_RcvDMtd='CRC') OR (_RcvDMtd='DBC')) THEN
			_CashAmt:=_RcvDAmt;
			
			IF (_RcvDMtd='CRC') THEN
				_CashANote:='Penerimaan #'||_RcvNo || ',Credit Card:' || COALESCE(_RcvDNote, '');
			ELSE  	-- RcvDMtd=DBC 
				_CashANote:='Penerimaan #'||_RcvNo || ',Debit Card:' || COALESCE(_RcvDNote, '');
			END IF;	
			
			SELECT INTO spretCashA_New * FROM spCashA_New(
				_CashID, _CustID, 'RCV', _RcvDate, 'I', 'RCV', _RcvNo, _CashAmt,
			   _ExtNote , TRUE, _CrtBy, _CrtDate, _UpdBy, _UpdDate,
				_PerID, _BranchID, _DeptID, _PrjID, _CrcIDRcvD, _ExcRateRcvD, _FisRateRcvD
			);
			IF spretCashA_New.ErrNo<>0 THEN
				_retval.ErrNo:=spretCashA_New.ErrNo;
				_retval.ErrMsg:=spretCashA_New.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
**/
		
			_CashAmt:=_RcvDAmt;

			IF(_RegRcvDNoteCashA='0') THEN
				_RcvDNote:='';
			END IF;
			
			IF (_RcvDMtd='BTRF') THEN
				_CashANote:='B.Tranfer, '||COALESCE(_RcvDNote, '')||COALESCE(':'||E'\nUntuk Bayar : '||_ExtNote,'');
			ELSIF (_RcvDMtd='CASH') THEN
				_CashANote:='Tunai, '||COALESCE(' '||_RcvDNote, '')||COALESCE(':'||E'\nUntuk Bayar : '||_ExtNote,'');
			ELSIF (_RcvDMtd='CRC') THEN
				_CashANote:='CCard, '||COALESCE(_RcvDNote, '')||COALESCE(':'||E'\nUntuk Bayar : '||_ExtNote,'');
			ELSIF (_RcvDMtd='DBC') THEN
				_CashANote:='DCard, '||COALESCE(_RcvDNote, '')||COALESCE(':'||E'\nUntuk Bayar : '||_ExtNote,'');
			END IF;

			IF(_RegRcvNoteCashA='1') THEN
				_CashANote:='Cara Bayar : '||_CashANote||E'\nKeterangan : '||COALESCE(_RcvNote,'');
			ELSE
				_CashANote:='Cara Bayar : '||_CashANote;
			END IF;

			IF(_BranchID IS NOT NULL OR _BranchID!='') THEN
				_CashANote:=_CashANote||E' :\nCabang : '||COALESCE(_BranchName,'');
			END IF;
			
			SELECT INTO _isAutoReconcileIn isAutoReconcileIn FROM Cash WHERE CashID=_CashID;

			IF ((_RcvDMtd='CASH' OR _RcvDMtd='BTRF') AND (_isAutoReconcileIn=FALSE)) THEN
				SELECT INTO spretCashA_New * FROM spCashA_New(
					_CashID, _CustID, 'RCV', _RcvDate, 'I', 'RCV', _RcvNo, _CashAmt,
				   _CashANote , TRUE, _CrtBy, _CrtDate, _UpdBy, _UpdDate,
					_PerID, _BranchID, _DeptID, _PrjID, _CrcIDRcvD, _ExcRateRcvD, _FisRateRcvD
				);
				IF spretCashA_New.ErrNo<>0 THEN
					_retval.ErrNo:=spretCashA_New.ErrNo;
					_retval.ErrMsg:=spretCashA_New.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;

				--- saat ini block diatas sama dengan block dibawah, karena d spCashA_New nanti isReconcile akan dicheck & kas tidak akan bertambah/kurang apabila autoreconcilenya FALSE
			ELSE
				SELECT INTO spretCashA_New * FROM spCashA_New(
					_CashID, _CustID, 'RCV', _RcvDate, 'I', 'RCV', _RcvNo, _CashAmt,
				   _CashANote , TRUE, _CrtBy, _CrtDate, _UpdBy, _UpdDate,
					_PerID, _BranchID, _DeptID, _PrjID, _CrcIDRcvD, _ExcRateRcvD, _FisRateRcvD
				);
				IF spretCashA_New.ErrNo<>0 THEN
					_retval.ErrNo:=spretCashA_New.ErrNo;
					_retval.ErrMsg:=spretCashA_New.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END IF;


		ELSIF((_RcvDMtd='CHQ') OR (_RcvDMtd='GIRO')) THEN

			SELECT INTO 
				_inout,_ACTIVE,_BPID,_srccash,_CbgDate,_CbgAmt,_NomerCbg,_ClrDate 
				inout,active,frombpid,srccashid,cbgdate,cbgamt,cbgno,clrdate 
			FROM cbg WHERE cbgid=_CbgID;

			IF(_inout<>'I') THEN
				_retval.ErrNo:=5001;
				_retval.ErrMsg:='Tipe Cek/BG harus IN! (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
			IF(_ClrDate is NOT NULL) THEN
				_retval.ErrNo:=50002;
				_retval.ErrMsg:='Cek/BG #'||_CbgID||' sudah di-Clearingkan (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
			IF (_CbgID IS NULL) THEN
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Cek/BG belum diset  (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
			SELECT INTO _ACTIVE active FROM cbg WHERE CBGID=_CbgID;
			IF (_ACTIVE=false) then
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Cek/BG tidak aktif (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
			IF (_inout='I') AND (_bpid<>_CustID) then
				_retval.ErrNo:=101;
				_retval.ErrMsg:='MitraBisnis tidak sama dengan di Cek/BG!! (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF(_CbgAmt<>_RcvDAmt) then
				_retval.ErrNo:=101;
				_retval.ErrMsg:='Jumlah Pembayaran dengan Cek/BG Harus memiliki jumlah yang sama Cek/BG-nya! (spRcv_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
			_ExtNote:='C/BG '||_NomerCbg||' dari '||_CustID;

			SELECT INTO spretCashA_New * FROM spCashA_New(
				_srccash, _BPID, 'CBG', _RcvDate, 'I', 'CBG', _CbgID, _CbgAmt,
				_ExtNote , TRUE, NULL, NULL, NULL, NULL,NULL, NULL, NULL, NULl,_CrcIDRcvD, _ExcRateRcvD, _FisRateRcvD);
			IF spretCashA_New.ErrNo<>0 THEN
				_retval.ErrNo:=spretCashA_New.ErrNo;
				_retval.ErrMsg:=spretCashA_New.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
			UPDATE cbg SET active=false, useddate=_RcvDate WHERE cbgid=_CbgID;
		
		END IF;
	END LOOP;
	CLOSE cRcvD;

	SELECT INTO _ExcRateSPaid excrate FROM spaid WHERE rcvno=_RcvNo;

	IF _RcvType='RCV' THEN	
		/*--_DebtAmt:=_TotSPaid*(-1);		--penerimaan : potong piutang (-) */
		_DebtAmt:=_totBpAmt*(-1);
		_DebtNote:='Penerimaan #'||_RcvNo;

		SELECT INTO spretDebt_New * from spBPA_New(
			_CustID, 'P',_CrcID, _RcvDate, 'RCV', _RcvNo, _DebtAmt, _DebtNote, true, 
			_CrtBy, _CrtDate, _UpdBy, _UpdDate,
			_PerID, _BranchID, _DeptID, _PrjID,_ExcRateSPaid, _FisRateSPaid
		);

		IF spretDebt_New.ErrNo<>0 THEN
			_retval.ErrNo:=spretDebt_New.ErrNo;
			_retval.ErrMsg:=spretDebt_New.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	END IF;
	SELECT INTO _CrcIDDefa CrcID FROM Crc where isdefault=true;


/************************************ AKUNTANSI ******************************************/

	IF isAccInstalled() AND _isAutoGen=false THEN
		IF(_IsRetur=TRUE AND _TotSPaid=0) THEN
			_retval:=(0, 'OK');
		ELSE
			/** cek akun dp */
			IF (_RcvType='DP') THEN
				_AccDP:=fAccDefault('DEPOCUST');
				IF (_AccDP IS NULL OR _AccDP='') THEN
					_retval.ErrNo:=50555;
					_retval.ErrMsg:=E'Default akun deposit Customer belum disetting\nSilahkan disetting melalui form default akun (spRcv_New)';
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END IF;

			_JnlNo:=fTransNoGet('JURNAL');
			IF (_RcvType='DP') THEN
				_JnlNote:='Penerimaan Uang Muka ';
			ELSE
				_JnlNote:='Penerimaan ';				
			END IF;

			IF (_RegRcvNoteJnl='0') THEN
				_RcvNote:='';
			END IF;

			IF (_RcvNote IS NULL OR _RcvNote='') THEN
				_JnlNote:= ''||_JnlNote||''||fBPName(_CustID)||':'||_RcvNo;
			ELSE
				_JnlNote:= ''||_JnlNote||''||fBPName(_CustID)||':'||_RcvNo||E' \nKeterangan : '|| _RcvNote;
			END IF;
			SELECT INTO _spret * FROM spJnl_Insert(
				_JnlNo, 'RCV', _RcvDate, 'RCV', _RcvNo,
				_JnlNote,true,true,cast(0 as NUMERIC(19,4)),
				_CrtBy,_CrtDate,_UpdBy,_UpdDate,
				_PerID, _BranchID, _DeptID, _PrjID, _CrcID, _ExcRate, _FisRate
			);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			_Count:=0;
			OPEN cRcvD FOR
				SELECT RcvDMtd, CashID, RcvdAmt, RefNo, RcvDNote, ExcRate, cbgid
				FROM RcvD WHERE RcvNo=_RcvNo;
			LOOP
				FETCH cRcvD INTO _RcvDMtd, _CashID, _RcvDAmt, _RcvD_RefNo, _RcvDNote, _ExcRateRcvD, _CbgID;
				EXIT WHEN NOT FOUND;
			
				_Count:=_Count+1;
				IF (_RcvDMtd='OVER') THEN
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, fAccDefault('DEPOCUST'), 'D', _RcvDAmt*_ExcRateRcvD, NULL, NULL, _RcvDAmt);

				ELSIF ((_RcvDMtd='CASH') OR (_RcvDMtd='BTRF') OR (_RcvDMtd='DBC') OR (_RcvDMtd='CRC')) THEN
					_AccCash:=fAccCash(_CashID, _CashInOut);

					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _AccCash, 'D', _RcvDAmt*_ExcRateRcvD, NULL, NULL, _RcvDAmt);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;

				ELSIF((_RcvDMtd='CHQ') OR (_RcvDMtd='GIRO')) THEN
					SELECT INTO _CashCBG srccashid FROM cbg WHERE cbgid=_CbgID;
					_AccCash:=fAccCash(_CashCBG, _CashInOut);
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _AccCash, 'D', _RcvDAmt*_ExcRateRcvD, NULL, NULL, _RcvDAmt);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				END IF;
			END LOOP;
			CLOSE cRcvD;

			SELECT INTO _SPaidAmtSret, _SPaidAmtSretAsli SUM(spaidamt*excrate), SUM(spaidamt) 
			FROM SPaid WHERE RcvNo=_RcvNo AND reftype='SRET';

			_SPaidAmtSret:=COALESCE(_SPaidAmtSret, 0);
			_SPaidAmtSretAsli:=COALESCE(_SPaidAmtSretAsli,0);
		
			SELECT INTO _SPaidAmtSO, _SPaidAmtSOAsli SUM(spaidamt*excrate), SUM(spaidamt) 
			FROM SPaid WHERE RcvNo=_RcvNo AND reftype='SO';

			_SPaidAmtSO:=COALESCE(_SPaidAmtSO, 0);
			_SPaidAmtSOAsli:=COALESCE(_SPaidAmtSOAsli,0);
			
			SELECT INTO 
				_SPaidAmtFCN, _SPaidAmtFCNAsli 
				SUM(spaidamt*excrate), SUM(spaidamt) 
			FROM spaid WHERE rcvno=_RcvNo and reftype='FCN';

			_SPaidAmtFCN:=COALESCE(_SPaidAmtFCN, 0);
			_SPaidAmtFCNAsli:=COALESCE(_SPaidAmtFCNAsli, 0);

			_IsPosted:=false;

			OPEN cSPaid FOR
				SELECT reftype, (CASE WHEN reftype='SALE' THEN fAccTrans('SALE', refno, 'AR') WHEN reftype='DP' THEN _AccDP ELSE refno END), 
				SUM(spaidamt*excrate), SUM(spaidamt), deptid, prjid, crcid, SUM(spaidnote) 
				FROM spaid 
				WHERE rcvno=_RcvNo AND reftype NOT IN ('SRET', 'FCN')
				GROUP BY reftype, (CASE WHEN reftype='SALE' THEN fAccTrans('SALE', refno, 'AR') WHEN reftype='DP' THEN _AccDP ELSE refno END), deptid, prjid, crcid;
			LOOP
				FETCH cSPaid INTO _RefType, _RefNo, _SPaidAmt, _SPaidAmtAsli, _DeptID, _PrjID, _CrcIDSPaid, _SPaidNote;
				EXIT WHEN NOT FOUND;
				_Count:=_Count+1;

				IF(_RegSPaidNoteJnl='0') THEN 
					_SPaidNote:='';
				ELSE
					_SPaidNote:=E'\nUntuk Bayar : '||_SPaidNote||'';
				END IF;

				IF _RefType='SALE' THEN
					IF((_SPaidAmtSret!=0 OR _SPaidAmtFCN!=0) AND (_IsPosted=false)) THEN
					--SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo,_Count,fBpAcc(_CustID,_CrcIDSPaid,'AR'),'K',(_SPaidAmt*_ExcRateSPaid)+_SPaidAmtSret,_DeptID,_PrjID,_SPaidAmt+_SPaidAmtSretAsli);
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _RefNo, 'K', _SPaidAmt+_SPaidAmtSret+_SPaidAmtFCN, _DeptID, _PrjID, _SPaidNote, _SPaidAmtAsli+_SPaidAmtSretAsli+_SPaidAmtFCNAsli);
						_IsPosted:=true;
					ELSE
					--SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo,_Count,fBpAcc(_CustID,_CrcIDSPaid,'AR'),'K',_SPaidAmt*_ExcRateSPaid,_DeptID,_PrjID,_SPaidAmt);
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _RefNo, 'K', _SPaidAmt, _DeptID, _PrjID, _SPaidNote, _SPaidAmtAsli);
					END IF;
				ELSIF _RefType='ACC' THEN
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _RefNo, 'K', _SPaidAmt, _DeptID, _PrjID, _SPaidNote, _SPaidAmt);
				ELSIF _RefType='DP' THEN
					IF (_RcvType='DP') THEN
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _RefNo, 'K', _SPaidAmt, _DeptID, _PrjID, _SPaidNote, _SPaidAmtAsli);
					ELSE
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _RefNo, 'K', _SPaidAmt, _DeptID, _PrjID, _SPaidNote, _SPaidAmtAsli);
					END IF;
				END IF;
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END LOOP;
			CLOSE cSPaid;

			_OverRcvBC:=COALESCE(_OverRcvBC, 0);
			IF (_OverRcvBC<>0) THEN
				_AccOver:=fAccDefault('DEPOCUST');

				_Count:=_Count+1;
				SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _AccOver, 'K', _OverRcvBC, NULL, NULL, _OverRcv);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END IF;

			_TotRcvDiscBC:=COALESCE(_TotRcvDiscBC,0);
			IF(_TotRcvDiscBC<>0) THEN
				_AccDisc:=fAccDefault('SALEDISC');
				_Count:=_Count+1;
				SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo, _Count, _AccDisc, 'D', _TotRcvDiscBC, NULL, NULL, _TotRcvDisc);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END IF;

			------------  Trigger post Jurnal -------------
			SELECT INTO _spret * FROM spJnl_New(_JnlNo);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			--- Jurnal klo buat ada selisih kurs saat ini ama pembelian waktu itu 
			-- cek saldo buat ngitung selisih kurs

			_saldoAkhir:=0;
			OPEN cSPaid FOR
				SELECT reftype, refno, spaidamt 
				FROM spaid 
				WHERE rcvno=_RcvNo AND crcid<>_CrcIDDefa AND reftype IN ('SALE', 'SRET');
			LOOP
				FETCH cSPaid INTO _RefType, _RefNo, _PaidAmt;
				EXIT WHEN NOT FOUND;

				_PaidAmtBC:=_PaidAmt*_Excrate;

				IF(_RefType='SALE') THEN

					SELECT INTO _ExcRateSale excrate FROM sale WHERE saleno=_RefNo;
				
					_SPaidAmtBCSale:=_PaidAmt*_ExcRateSale;
					_saldo:=_SPaidAmtBCSale-_PaidAmtBC;
				ELSIF(_RefType='SRET') THEN
					SELECT INTO _ExcRateSRet excrate FROM sret WHERE sretno=_RefNo;
				
					_SPaidAmtBCSRet:=_PaidAmt*_ExcRateSRet;
				
					_saldo:=_SPaidAmtBCSRet-_PaidAmtBC;
				END IF;

				_saldoAkhir:=_saldoAkhir+COALESCE(_saldo, 0);
			END LOOP;
			CLOSE cSPaid;

			IF (_RcvType!='DP') THEN
				SELECT INTO _DPRevaluation SUM((a.spaidamt*dp.excrate) - (a.spaidamt*a.excrate)) 
				FROM dp JOIN (
					SELECT CAST(refno AS BIGINT) AS dpid, spaidamt, excrate 
					FROM spaid 
					WHERE reftype='DP' AND rcvno=_RcvNo
				) a ON dp.dpid=a.dpid;

				_DPRevaluation:=COALESCE(_DPRevaluation, 0)*-1;
				_RevaluationWithoutDP:=_saldoAkhir;
				_saldoAkhir:=_saldoAkhir+_DPRevaluation;
			END IF;
--RAISE EXCEPTION 'saldo : % , dp reva : %, without : % ',_saldoAkhir,_DPRevaluation,_RevaluationWithoutDP;
			IF(_saldoAkhir<>0 OR _DPRevaluation<>0 OR _RevaluationWithoutDP<>0) THEN
				_RevalDNo:=0;
				_JnlNo1:=fTransNoGet('JURNAL');
				_JnlNote1:= 'Revaluasi Kurs Penerimaan'||':'||_RcvNo;

				SELECT INTO _spret * FROM spJnl_Insert(_JnlNo1,'RCV',_RcvDate,'RCV',_RcvNo,
					_JnlNote1,true,true,CAST(0 AS NUMERIC(19,4)),_CrtBy,_CrtDate,_UpdBy,_UpdDate,
					_PerID, _BranchID, _DeptID, _PrjID, __xt, _CrcID, _ExcRate, _FisRate
				);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;

				IF (_saldoAkhir>0) THEN
					_RevalDNo:=_RevalDNo+1;
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _RevalDNo, fAccDefault('ACCPROFIT'), 'D', _saldoAkhir, NULL, NULL, _saldoAkhir);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				ELSIF (_saldoAkhir<0) THEN
					_RevalDNo:=_RevalDNo+1;
					_saldoAkhir:=ABS(_saldoAkhir);
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _RevalDNo, fAccDefault('ACCPROFIT'), 'K', _saldoAkhir, NULL, NULL, _saldoAkhir);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				END IF;

				IF (_RevaluationWithoutDP>0) THEN
					_RevalDNo:=_RevalDNo+1;
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _RevalDNo, fBpAcc(_CustID, _CrcID, 'AR'), 'K', _RevaluationWithoutDP, NULL, NULL, _RevaluationWithoutDP);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				ELSIF (_RevaluationWithoutDP<0) THEN
					_RevalDNo:=_RevalDNo+1;
					_RevaluationWithoutDP:=ABS(_RevaluationWithoutDP);
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _RevalDNo, fBpAcc(_CustID, _CrcID, 'AR'), 'D', _RevaluationWithoutDP, NULL, NULL, _RevaluationWithoutDP);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF; 
				END IF;

				IF (_DPRevaluation>0) THEN
					_RevalDNo:=_RevalDNo+1;
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _RevalDNo, _AccDP, 'K', _DPRevaluation, NULL, NULL, _DPRevaluation);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				ELSIF (_DPRevaluation<0) THEN
					_RevalDNo:=_RevalDNo+1;
					_DPRevaluation:=ABS(_DPRevaluation);
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _RevalDNo, _AccDP, 'D', _DPRevaluation, NULL, NULL, _DPRevaluation);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				END IF;

				SELECT INTO _spret * FROM spJnl_New(_JnlNo1);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END IF;
		END IF;
	END IF;

	_retval:=(0, 'OK');
	RETURN NEXT _retval;
END;
$BODY$ 
LANGUAGE 'plpgsql' VOLATILE;


